﻿/*globals document DOM EXEMPLES GUI */

var AUX = {
	num: 0,
	sp: "\t",
	k: 0
};

//================== Arbre ==================
function Arbre(pere) {
	if (pere) {
		this.pere = pere;
		AUX.num += 1;
		this.noeud = "Nœud" + AUX.num;
		this.arcDuPere = "Arc" + AUX.num;
		this.commentaire =  "Commentaire" + AUX.num;
	} else {
		this.pere = null;
		AUX.num = 0;
		this.noeud = "Racine";
		this.arcDuPere = "?";
		this.commentaire =  "Commentaire";
	}
	this.fils =  [];
	this.widget =  null;
	this.widgetArc =  null;
	this.widgetNoeud =  null;
	this.widgetCommentaire =  null;
}

//============= Arbre.ajouterFils =============
Arbre.prototype.ajouterFils = function () {
	this.fils.push(new Arbre(this));
};

//============= Arbre.supprimerFils =============
Arbre.prototype.supprimerFils = function (arbre) {
	var k = this.fils.indexOf(arbre);
	this.fils.splice(k, 1);
};

//============= Arbre.monterFils =============
Arbre.prototype.monterFils = function () {
	var k;
	if (this.pere) {
		k = this.pere.fils.indexOf(this);
		if (k > 0) {
			this.pere.fils.splice(k, 1);
			this.pere.fils.splice(k - 1, 0, this);
		}
	}
};

//============= Arbre.descendreFils =============
Arbre.prototype.descendreFils = function () {
	var k;
	if (this.pere) {
		k = this.pere.fils.indexOf(this);
		if (k < this.pere.fils.length - 1) {
			this.pere.fils.splice(k, 1);
			this.pere.fils.splice(k + 1, 0, this);
		}
	}
};

//============= Arbre.tuer =============
Arbre.prototype.tuer = function () {
	if (this.pere) {
		this.pere.supprimerFils(this);
	}
};

//============= Arbre.dimAux =============
Arbre.prototype.dimAux = function () {
	var k;
	AUX.dim[this.profondeur] = true;
	for (k = 0; k < this.fils.length; k += 1) {
		this.fils[k].dimAux();
	}
};

//============= Arbre.dimensionsTikZ =============
Arbre.prototype.dimensionsTikZ = function () {
	var txt, k, d, t, p, q;
	txt = "";
	AUX.dim = [];
	this.dimAux();
	d = AUX.dim.length;
	t = d - 1;
	q = t > 0 ? 1 / t : 0;
	p = 0;
	txt += "% Dimensions calculées (NON MODIFIABLES)\n";
	for (k = 0; k < d; k += 1) {
		if (GUI.orientation === "Droite" || GUI.orientation === "Haut") {
			txt += "\\def\\Niveau" + "ABCDEFGHIJKLMNOPQRSTUVWXYZ".substr(k, 1) + "{(-" + p + ")*\\DistanceInterNiveaux}\n";
		} else {
			txt += "\\def\\Niveau" + "ABCDEFGHIJKLMNOPQRSTUVWXYZ".substr(k, 1) + "{(" + p + ")*\\DistanceInterNiveaux}\n";
		}
		if (GUI.niveauxEquidistants || GUI.orientation === "Liste") {
			p += 1;
		} else {
			p += 1 + (t - k - 1) * q;
		}
	}
	if (GUI.orientation === "Haut" || GUI.orientation === "Bas") {
		txt += "\\def\\InterFeuilles{(1)*\\DistanceInterFeuilles}\n";
	} else {
		txt += "\\def\\InterFeuilles{(-1)*\\DistanceInterFeuilles}\n";
	}
	return txt;
};

//============= Arbre.noeudsTikZ =============
Arbre.prototype.noeudsTikZ = function () {
	var txt, k, nodeStyle;
	if (!this.pere) {
		AUX.k = 0;
	}
	if (this.style) {
		nodeStyle = "\\node[" + this.style + "] (";
	} else {
		nodeStyle = this.fils.length === 0 ? "\\node[feuille] (" : "\\node[noeud] (";
	}
	if (GUI.orientation === "Liste") {
		txt = nodeStyle + this.nomDuNode + ") at ({\\Niveau" + "ABCDEFGHIJKLMNOPQRSTUVWXYZ".substr(this.profondeur, 1) + "},{(" + AUX.k + ")*\\InterFeuilles}) {" + GUI.texteLaTeX(this.noeud) + "};\n";
		AUX.k += 1;
	} else if (GUI.orientation === "Haut" || GUI.orientation === "Bas") {
		txt = nodeStyle + this.nomDuNode + ") at ({(" + this.largeur + ")*\\InterFeuilles},{\\Niveau" + "ABCDEFGHIJKLMNOPQRSTUVWXYZ".substr(this.profondeur, 1) + "}) {" + GUI.texteLaTeX(this.noeud) + "};\n";
	} else {
		txt = nodeStyle + this.nomDuNode + ") at ({\\Niveau" + "ABCDEFGHIJKLMNOPQRSTUVWXYZ".substr(this.profondeur, 1) + "},{(" + this.largeur + ")*\\InterFeuilles}) {" + GUI.texteLaTeX(this.noeud) + "};\n";
	}
	if (GUI.avecCommentaires && this.fils.length === 0) {
		if (GUI.orientation === "Liste") {
			txt += "\\draw (" + this.nomDuNode + ".east) node[commentaire] {" + GUI.texteLaTeX(this.commentaire) + "};\n";
		} else if (GUI.orientation === "Droite") {
			txt += "\\draw (" + this.nomDuNode + ".west) node[commentaire] {" + GUI.texteLaTeX(this.commentaire) + "};\n";
		} else if (GUI.orientation === "Haut") {
			txt += "\\draw (" + this.nomDuNode + ".south) node[commentaire] {" + GUI.texteLaTeX(this.commentaire) + "};\n";
		} else if (GUI.orientation === "Bas") {
			txt += "\\draw (" + this.nomDuNode + ".north) node[commentaire] {" + GUI.texteLaTeX(this.commentaire) + "};\n";
		} else {
			txt += "\\draw (" + this.nomDuNode + ".east) node[commentaire] {" + GUI.texteLaTeX(this.commentaire) + "};\n";
		}
	}
	for (k = 0; k < this.fils.length; k += 1) {
		txt += this.fils[k].noeudsTikZ();
	}
	return txt;
};

//============= Arbre.arcsTikZ =============
Arbre.prototype.arcsTikZ = function () {
	var txt, k;
	txt = "";
	if (this.pere) {
		if (GUI.orientation === "Liste") {
			txt += "\\draw[fleche] (" + this.pere.nomDuNode + ".north west)|-(" + this.nomDuNode + ")";
		} else {
			txt += "\\draw[fleche] (" + this.pere.nomDuNode + ")--(" + this.nomDuNode + ")";
		}
		if (GUI.avecArcs) {
			txt += " node[etiquette] {" + GUI.texteLaTeX(this.arcDuPere) + "};\n";
		} else {
			txt += ";\n";
		}
	}
	for (k = 0; k < this.fils.length; k += 1) {
		txt += this.fils[k].arcsTikZ();
	}
	return txt;
};

//============= Arbre.init =============
Arbre.prototype.init = function () {
	// réinitialisation de la racine
	if (this.pere) {
		// on ne fait rien si ce n'est pas la racine
		return;
	}
	AUX.num = 0;
	this.arcDuPere = "?";
	this.noeud = "Racine";
	this.commentaire =  "Commentaire";
	this.fils = [];
	this.widget = null;
	this.widgetArc = null;
	this.widgetNoeud = null;
	this.widgetCommentaire = null;
};

//============= Arbre.lireInput =============
Arbre.prototype.lireInput = function () {
	var k;
	if (this.widgetArc) {
		this.arcDuPere = this.widgetArc.value;
	}
	this.noeud = this.widgetNoeud.value;
	if (this.widgetCommentaire) {
		this.commentaire = this.widgetCommentaire.value;
	}
	for (k = 0; k < this.fils.length; k += 1) {
		this.fils[k].lireInput();
	}
};

//============= Arbre.definrAvec =============
Arbre.prototype.definrAvec = function (exo) {
	var k;
	this.noeud = exo.noeud;
	if (exo.arcDuPere) {
		this.arcDuPere = exo.arcDuPere;
	}
	if (exo.commentaire) {
		this.commentaire = exo.commentaire;
	}
	if (exo.fils) {
		for (k = 0; k < exo.fils.length; k += 1) {
			this.ajouterFils();
		}
		for (k = 0; k < this.fils.length; k += 1) {
			this.fils[k].definrAvec(exo.fils[k]);
		}
	}
	if (exo.style) {
		this.style = exo.style;
	}
};

//============= Arbre.definirProfondeur =============
Arbre.prototype.definirProfondeur = function (n) {
	var k;
	this.profondeur = n;
	for (k = 0; k < this.fils.length; k += 1) {
		this.fils[k].definirProfondeur(n + 1);
	}
};

//============= Arbre.numeroterLesFeuilles =============
Arbre.prototype.numeroterLesFeuilles = function () {
	var k;
	if (this.fils.length === 0) {
		this.numeroFeuille = AUX.k;
		AUX.k += 1;
	} else {
		this.numeroFeuille = null;
		for (k = 0; k < this.fils.length; k += 1) {
			this.fils[k].numeroterLesFeuilles();
		}
	}
};

//============= Arbre.premiereFeuille =============
Arbre.prototype.premiereFeuille = function () {
	if (this.fils.length === 0) {
		return this.numeroFeuille;
	} else {
		return this.fils[0].premiereFeuille();
	}
};

//============= Arbre.derniereFeuille =============
Arbre.prototype.derniereFeuille = function () {
	if (this.fils.length === 0) {
		return this.numeroFeuille;
	} else {
		return this.fils[this.fils.length - 1].derniereFeuille();
	}
};

//============= Arbre.definirlargeur =============
Arbre.prototype.definirlargeur = function () {
	var k;
	this.largeur = (this.premiereFeuille() + this.derniereFeuille()) / 2;
	for (k = 0; k < this.fils.length; k += 1) {
		this.fils[k].definirlargeur();
	}
};

//============= Arbre.nommerLesNoeuds =============
Arbre.prototype.nommerLesNoeuds = function (nom) {
	var k;
	this.nomDuNode = nom;
	for (k = 0; k < this.fils.length; k += 1) {
		this.fils[k].nommerLesNoeuds(nom + "abcdefghijklmnopqrstuvwxyz".substr(k, 1));
	}
};

//============= Arbre.rafraichir =============
Arbre.prototype.rafraichir = function () {
	this.lireInput();
	this.definirProfondeur(0);
	AUX.k = 0;
	this.numeroterLesFeuilles();
	this.definirlargeur();
	this.nommerLesNoeuds("R");
};

//============= Arbre.prettyPrint =============
Arbre.prototype.prettyPrint = function (niveau) {
	var k, n, txt, indent;
	n = niveau ? niveau : 1;
	indent = "";
	for (k = 0; k < n; k += 1) {
		indent += AUX.sp;
	}
	txt = indent + "{\n";
	if (this.pere) {
		txt += indent + AUX.sp + 'arcDuPere: "' + this.arcDuPere + '",\n';
	}
	txt += indent + AUX.sp + 'noeud: "' + this.noeud + '"';
	if (this.fils.length > 0) {
		txt += ',\n';
		txt += indent + AUX.sp + 'fils: [\n';
		for (k = 0; k < this.fils.length; k += 1) {
			txt += this.fils[k].prettyPrint(n + 2) + (k < this.fils.length - 1 ? ",\n" : "\n");
		}
		txt += indent + AUX.sp + '],\n';
	} else if (GUI.avecCommentaires) {
		txt += ',\n';
		txt += indent + AUX.sp + 'commentaire: "' + this.commentaire + '",\n';
	} else {
		txt += ',\n';
	}
	txt += indent + AUX.sp + 'numeroFeuille: ' + this.numeroFeuille + ',\n';
	txt += indent + AUX.sp + 'nomDuNode: "' + this.nomDuNode + '",\n';
	txt += indent + AUX.sp + 'profondeur: ' + this.profondeur + ',\n';
	txt += indent + AUX.sp + 'largeur: ' + this.largeur + '\n';
	txt += indent + "}";
	return txt;
};

//============= Arbre.visualiser =============
Arbre.prototype.visualiser = function (b) {
	this.widget.className = "arbre" + (b ? " visu" : "");
};

//============= Arbre.creerWidget =============
Arbre.prototype.creerWidget = function (conteneur) {
	var div, ul, li, row, cell, k, btn;
	this.widget = DOM.elementDans(conteneur, "table", {classe: "arbre"});
	// Une Ligne
	row = this.widget.insertRow(0);
	row.vAlign = "middle";
	// Gauche
	k = 0;
	cell = row.insertCell(k);
	if (this.pere) {
		// Si ce n'est pas la racine on place un arc
		DOM.elementDans(cell, "br", {});
		DOM.elementDans(cell, "span", {html: "&rarr;", classe: "bleu"});
		if (GUI.avecArcs) {
			// case de saisie d'étiquete d'arc
			k += 1;
			cell = row.insertCell(k);
			DOM.elementDans(cell, "br", {});
			this.widgetArc = DOM.elementDans(cell, "input", {type: "text", classe: "arc", valeur: this.arcDuPere});
			k += 1;
			cell = row.insertCell(k);
			DOM.elementDans(cell, "br", {});
			DOM.elementDans(cell, "span", {html: "&rarr;", classe: "bleu"});
		}
		// case suivante
		k += 1;
		cell = row.insertCell(k);
	}
	// bouton pour tuer le noeud
	div = DOM.elementDans(cell, "div", {classe: "gauche"});
	if (this.pere) {
		btn = DOM.elementDans(div, "img", {image: "img/noeudKill.png", classe: "pointeur", onclick: "Code.clicTuer(this)", pop: "Supprimer le sous-arbre dont ce Nœud est la racine"});
		btn.arbre = this;
		// et les boutons de déplacement
		DOM.elementDans(div, "span", {html: " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; "});
		if (this.pere.fils.indexOf(this) > 0) {
			btn = DOM.elementDans(div, "img", {image: "img/noeudUp.png", classe: "pointeur", onclick: "Code.clicMonter(this)", pop: "Déplace ce nœeud au dessus de son frère précédent"});
			btn.arbre = this;
		} else {
			DOM.elementDans(div, "span", {html: "&nbsp; &nbsp;"});
		}
		DOM.elementDans(div, "span", {html: "&nbsp;"});
		if (this.pere.fils.indexOf(this) < this.pere.fils.length - 1) {
			btn = DOM.elementDans(div, "img", {image: "img/noeudDown.png", classe: "pointeur", onclick: "Code.clicDescendre(this)", pop: "Déplace ce nœeud au dessous de son frère suivant"});
			btn.arbre = this;
		}
	} else {
		DOM.elementDans(div, "img", {image: "img/noeudVide.png"});
	}
	// case de saisie d'étiquete de noeud
	this.widgetNoeud = DOM.elementDans(cell, "input", {type: "text", classe: "noeud", valeur: this.noeud});
	// commentaire ou liste des fils
	k += 1;
	cell = row.insertCell(k);
	if (this.fils.length === 0) {
		// pas de fils  -> bouton + et case de saisie de commentaire
		DOM.elementDans(cell, "br", {});
		btn = DOM.elementDans(cell, "img", {image: "img/noeudPlusFils.png", classe: "pointeur", onclick: "Code.clicAjouterFils(this)", pop: "Ajouter un Fils à ce Nœud"});
		btn.arbre = this;
		// éventuellement case de saisie de commentaire
		if (GUI.avecCommentaires) {
			k += 1;
			cell = row.insertCell(k);
			DOM.elementDans(cell, "br", {});
			this.widgetCommentaire = DOM.elementDans(cell, "input", {type: "text", classe: "commentaire", valeur: this.commentaire});
		}
	} else {
		// une liste de fils
		ul = DOM.elementDans(cell, "ul", {classe: "filsListe"});
		for (k = 0; k < this.fils.length; k += 1) {
			li = DOM.elementDans(ul, "li", {classe: "fils"});
			this.fils[k].creerWidget(li);
		}
		li = DOM.elementDans(ul, "li", {classe: "fils"});
		btn = DOM.elementDans(li, "img", {image: "img/noeudPlusFils.png", classe: "pointeur", onclick: "Code.clicAjouterFils(this)", pop: "Ajouter un Fils à ce Nœud"});
		btn.arbre = this;
	}
};
		