﻿/*globals document DOM Code Option */

var GUI = {
	modeMath: true,
	avecArcs: true,
	avecCommentaires: false,
	orientation: "Gauche",
	niveauxEquidistants: false
};

GUI.dom = {};

//============= GUI.creerMenuDebug =============
GUI.creerMenuDebug = function (n) {
	var k;
	Code.debug = false;
	GUI.dom.menu.options[0] = new Option("Exemples ?"); 
	for (k = 0; k < n; k += 1) {
		GUI.dom.menu.options[k + 1] = new Option("Exemple n° " + k); 
	}
};

//============= GUI.creerTable =============
GUI.creerTable = function () {
	var c, k, table, row, cell;
	DOM.effacerElement(GUI.dom.jeu);
	table = DOM.elementDans(GUI.dom.jeu, "table", {});
	table.align = "middle";
	// Ligne n° 1
	row = table.insertRow(0);
	GUI.dom.x = [];
	c = 0;
	cell = row.insertCell(c);
	GUI.dom.x[c] = DOM.elementDans(cell, "input", {classe: "un", type: "text"});
	GUI.dom.x[c].size = "7";
	c += 1;
	cell = row.insertCell(c);
	GUI.dom.x[c] = DOM.elementDans(cell, "input", {type: "text"});
	for (k = 2; k < Code.nbCol; k +=  1) {
		c += 1;
		cell = row.insertCell(c);
		c += 1;
		cell = row.insertCell(c);
		GUI.dom.x[k] = DOM.elementDans(cell, "input", {type: "text"});
	}
	// Ligne n° 2
	row = table.insertRow(1);
	GUI.dom.d = [];
	GUI.dom.s = [undefined];
	c = 0;
	cell = row.insertCell(c);
	GUI.dom.d[c] = DOM.elementDans(cell, "input", {classe: "un", type: "text"});
	GUI.dom.d[c].size = "7";
	c += 1;
	cell = row.insertCell(c);
	GUI.dom.d[c] = DOM.elementDans(cell, "input", {type: "text"});
	for (k = 2; k < Code.nbCol; k +=  1) {
		c += 1;
		cell = row.insertCell(c);
		GUI.dom.s[k - 1] = DOM.elementDans(cell, "input", {type: "text"});
		GUI.dom.s[k - 1].size = "2";
		c += 1;
		cell = row.insertCell(c);
		GUI.dom.d[k] = DOM.elementDans(cell, "input", {type: "text"});
	}
	// Ligne n° 3
	row = table.insertRow(2);
	GUI.dom.y = [];
	c = 0;
	cell = row.insertCell(c);
	GUI.dom.y[c] = DOM.elementDans(cell, "input", {classe: "un", type: "text"});
	GUI.dom.y[c].size = "7";
	c += 1;
	cell = row.insertCell(c);
	GUI.dom.y[c] = DOM.elementDans(cell, "input", {type: "text"});
	for (k = 2; k < Code.nbCol; k +=  1) {
		c += 1;
		cell = row.insertCell(c);
		c += 1;
		cell = row.insertCell(c);
		GUI.dom.y[k] = DOM.elementDans(cell, "input", {type: "text"});
	}
};

//============= GUI.initZoneTexte =============
GUI.initZoneTexte = function (div) {
	// Zone de source TikZ
	DOM.elementDans(div, "br", {});
	GUI.dom.texte = DOM.elementDans(div, "textarea", {id: "sourceTikZ"});
	GUI.dom.texte.rows = "25";
	GUI.dom.texte.cols = "120";
	// Bouton RaZ
	DOM.elementDans(div, "br", {});
	DOM.elementDans(div, "button", {type: "button", classe: "pointeur", onclick: "Code.clicRAZ()", html: "Remise à Zéro"});
};

//============= GUI.initZoneDeJeu =============
GUI.initZoneDeJeu = function () {
	var table, row, cell;
	// Zone de source TikZ
	table = DOM.elementDans(document.body, "table", {});
	table.cellSpacing = "5";
	// Ligne n° 1
	row = table.insertRow(0);
	row.vAlign = "middle";
	// Gauche
	cell = row.insertCell(0);
	// Zone de définition du jeu (vide au départ)
	GUI.dom.jeu = DOM.elementDans(cell, "div", {id: "jeu"});
	// Arcs étiquetés
	DOM.elementDans(cell, "input", {type: "checkbox", onchange: "Code.clicArcs(this)", pop: "Pour supprimer les étiquettes des arcs de l'arbre"}).checked = true;
	DOM.elementDans(cell, "span", {classe: "info", html: "Arcs étiquetés &nbsp; &nbsp; "});
	// Feuilles commentées
	DOM.elementDans(cell, "input", {type: "checkbox", onchange: "Code.clicCommentaires(this)", pop: "Pour ajouter des commentaires aux feuilles de l'arbre"});
	DOM.elementDans(cell, "span", {classe: "info", html: "Feuilles commentées"});
	// Centre
	cell = row.insertCell(1);
	cell.align = "left";
	// Boutons d'édition
	DOM.elementDans(cell, "b", {classe: "info", html: "Aide à l'édition :"});
	DOM.elementDans(cell, "br", {});
	DOM.elementDans(cell, "img", {image: "img/btnPoint.png", classe: "pointeur", onclick: "GUI.clicMacro(1)", pop: "Puce pour la Racine"});
	DOM.elementDans(cell, "img", {image: "img/btnP100.png", classe: "pointeur", onclick: "GUI.clicMacro(2)", pop: "Pourcentage"});
	DOM.elementDans(cell, "img", {image: "img/btnFrac.png", classe: "pointeur", onclick: "GUI.clicMacro(3)", pop: "Fraction"});
	DOM.elementDans(cell, "img", {image: "img/btnNonA.png", classe: "pointeur", onclick: "GUI.clicMacro(4)", pop: "A barre ou non-A"});
	DOM.elementDans(cell, "img", {image: "img/btnCap.png", classe: "pointeur", onclick: "GUI.clicMacro(5)", pop: "Intersection"});
	DOM.elementDans(cell, "img", {image: "img/btnCup.png", classe: "pointeur", onclick: "GUI.clicMacro(6)", pop: "Réunion"});
	DOM.elementDans(cell, "br", {});
	GUI.dom.macro = DOM.elementDans(cell, "textarea", {id: "macroTikZ"});
	GUI.dom.macro.rows = "1";
	GUI.dom.macro.cols = "22";
	// Droite
	cell = row.insertCell(2);
	cell.align = "left";
	cell.style.minWidth = "12em";
	DOM.elementDans(cell, "p", {classe: "info", html: "Clic sur un des exemples<br /><br />Copier le contenu de la case<br />Coller le dans une case de l'Arbre"});
};

//============= GUI.clicMacro =============
GUI.clicMacro = function (n) {
	switch (n) {
	case 1:
		GUI.dom.macro.value = "\\bullet";
		break;
	case 2:
		GUI.dom.macro.value = "25\\%";
		break;
	case 3:
		GUI.dom.macro.value = "\\dfrac{a}{b}";
		break;
	case 4:
		GUI.dom.macro.value = "\\overline{A}";
		break;
	case 5:
		GUI.dom.macro.value = "\\cap";
		break;
	case 6:
		GUI.dom.macro.value = "\\cup";
		break;
	}
	GUI.dom.macro.focus();
	GUI.dom.macro.select();
};

//================== GUI.clicAide ==================
GUI.clicAide = function () {
	if (GUI.dom.aide.className) {
		GUI.dom.btnAide.innerHTML = "Cacher le mode d'emploi";
		GUI.dom.aide.className = null;
	} else {
		GUI.dom.btnAide.innerHTML = "Mode d'emploi";
		GUI.dom.aide.className = "invisible";
	}
};

//============= GUI.clicModeEdit =============
GUI.clicModeEdit = function (widget) {
	GUI.modeMath = !GUI.modeMath;
	if (GUI.modeMath) {
		widget.innerHTML = "<tt>{$Mathématiques$}</tt>";
		widget.title = "Le contenu des cases de saisie est interprété comme une formule mathématique et encadré avec des $ dans le code source";
	} else {
		widget.innerHTML = "<tt>{Text}</tt>";
		widget.title = "Le contenu des cases de saisie est interprété comme du texte simple et copié tel quel dans le code source";
	}
};

//============= GUI.texteLaTeX =============
GUI.texteLaTeX = function (txt) {
	if (GUI.modeMath) {
		return "$" + txt + "$";
	} else {
		return txt;
	}
};

//================== GUI.init ==================
GUI.init = function () {
	var div;
	// Zone d'affichage de l'aide
	GUI.dom.aide = document.getElementById("aide");
	// le menu des exemples
	GUI.dom.menu = document.getElementById("menu");
	// le texte source
	// le menu des exemples
	GUI.dom.menuDebug = document.getElementById("menuDebug");
	// Zone d'affichage du bouton d'aide
	GUI.dom.btnAide = document.getElementById("btnAide");
	// Création de l'interface
	// Zone de définition du jeu (vide au départ)
	GUI.initZoneDeJeu();
	// Boutons de contrôles du jeu
	div = DOM.elementDans(document.body, "div", {classe: "controle"});
	DOM.elementDans(div, "hr", {});
	DOM.elementDans(div, "img", {image: "img/TikZ.png", classe: "pointeur", onclick: "Code.clicValider()", pop: "Engendrer le code TikZ de l'arbre"});
	// Mode d'écriture
	div = DOM.elementDans(document.body, "div", {});
	DOM.elementDans(div, "tt", {html: "<small>Mode d'écriture </small>"});
	DOM.elementDans(div, "button", {type: "button", html: "<tt>{$Mathématiques$}</tt>", classe: "btnModeEdit", onclick: "Code.clicModeEdit(this)", pop: "Le contenu des cases de saisie est interprété comme une formule mathématique et encadré avec des $ dans le code source"});
	div = DOM.elementDans(document.body, "div", {classe: "controle"});
	// Case à cocher de contrôles de Niveaux équidistants
	DOM.elementDans(div, "input", {type: "checkbox", onclick: "Code.clicNiveaux(this)"});
	DOM.elementDans(div, "span", {html: "Niveaux équidistants &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; Type d'arbre : &nbsp; "});
	// Boutons de contrôles radio d'orientation
	DOM.elementDans(div, "input", {type: "radio", nom: "orientation", valeur: "Gauche", onclick: "Code.clicOrientation(this)"}).checked = true;
	DOM.elementDans(div, "img", {image: "img/racGauche.png"});
	DOM.elementDans(div, "span", {html: " &nbsp; &nbsp; &nbsp; "});
	DOM.elementDans(div, "input", {type: "radio", nom: "orientation", valeur: "Droite", onclick: "Code.clicOrientation(this)"});
	DOM.elementDans(div, "img", {image: "img/racDroite.png"});
	DOM.elementDans(div, "span", {html: " &nbsp; &nbsp; &nbsp; "});
	DOM.elementDans(div, "input", {type: "radio", nom: "orientation", valeur: "Haut", onclick: "Code.clicOrientation(this)"});
	DOM.elementDans(div, "img", {image: "img/racHaut.png"});
	DOM.elementDans(div, "span", {html: " &nbsp; &nbsp; &nbsp; "});
	DOM.elementDans(div, "input", {type: "radio", nom: "orientation", valeur: "Bas", onclick: "Code.clicOrientation(this)"});	
	DOM.elementDans(div, "img", {image: "img/racBas.png"});
	DOM.elementDans(div, "span", {html: " &nbsp; &nbsp; &nbsp; "});
	DOM.elementDans(div, "input", {type: "radio", nom: "orientation", valeur: "Liste", onclick: "Code.clicOrientation(this)"});	
	DOM.elementDans(div, "img", {image: "img/racListe.png"});
	GUI.initZoneTexte(div);
	Code.init();
};
